﻿package
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.display.GradientType;
	import flash.display.SpreadMethod;
	import flash.display.Shape;
	//
	import flash.text.TextField;
    import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFieldAutoSize;
	import flash.text.Font;
	//
	import flash.filters.BitmapFilterQuality;
	import flash.filters.DropShadowFilter;
	//
	import flash.events.MouseEvent;
	//
	import flash.geom.Matrix;
    
    public class GraphicButton extends SimpleButton{
		
		private var w:uint;
		private var h:uint;
		private var colorone:uint;
    	private var colortwo:uint;
        private var borderColor:uint;
        private var borderSize:uint;
        private var cornerRadius:uint;
        private var gutter:uint = 5;
		private var box:Sprite;
		private var label:TextField;
		private var format:TextFormat;
        private var labelText:String;
		private var strong:Boolean;
		private var fontstyle:Font;
		private var fontsize:uint;
		private var fontcolor:uint;
		private var drop:Object;

		public function GraphicButton(clip:MovieClip,w:uint = 140,h:uint = 100,colorone:uint = 0xb2b2b2,colortwo:uint = 0x6d6d6d,borderColor:uint = 0x6d6d6d,borderSize:uint = 0,cornerRadius:uint = 10,labelText:String = "Button",strong:Boolean = true,fontsize:uint = 12,fontcolor:uint = 0xFFFFFF,reflect:Boolean = true,dropshadow:Boolean = true,drop:Object = ""){

			 this.w = w;
			 this.h = h;
			 this.borderColor = borderColor;
			 this.borderSize = borderSize;
			 this.cornerRadius = cornerRadius;
			 this.labelText = labelText;
			 this.strong = strong;
			 this.fontstyle = new Fontstyle();
			 this.fontsize = fontsize;
			 this.fontcolor = fontcolor;
			 if(drop == ""){
				this.drop = new Object();
				this.drop.angle = 45;
			 	this.drop.alphashadow = 40;
			 	this.drop.blur = 2;
			 	this.drop.distance = 4;
			 }else{
				this.drop = drop;
			 }
			 this.colorone = colorone;
			 this.colortwo = colortwo;
			 var shapeone = this.doDrawRoundRect(this.colorone,this.colortwo);
			 this.box = new Sprite();
			 this.box.addChild(shapeone);
			 if(reflect){
				 var reflection = this.doReflection();
				 this.box.addChild(reflection);
			 }
			 if(dropshadow){
			 	this.doDropShadow(this.box);
			 }
			 this.configureLabel();
			 this.downState = this.box;
        	 this.overState = this.box;
        	 this.upState = this.box;
        	 this.hitTestState = this.box;
			 this.hitTestState.x = 0;
        	 this.hitTestState.y = 0;
        	 this.useHandCursor  = true;
			 clip.addChild(this);
        }
		
		private function doDrawRoundRect(colorone:uint,colortwo:uint):Shape {
            var child:Shape = new Shape();
			var fillType:String = GradientType.LINEAR;
			var colors:Array = [colorone, colortwo];
			var alphas:Array = [1, 1];
			var ratios:Array = [0x00, 0xFF];
			var matr:Matrix = new Matrix();
			matr.createGradientBox(this.w/2, this.h, Math.PI / 2, 0, 0);
			var spreadMethod:String = SpreadMethod.PAD;
			child.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr, spreadMethod);
			if(this.borderSize != 0){
            	child.graphics.lineStyle(this.borderSize, this.borderColor);
			}
            child.graphics.drawRoundRect(0, 0, this.w, this.h, this.cornerRadius);
            child.graphics.endFill();
			return child;
        }
		
		private function doReflection():Shape {
            var child:Shape = new Shape();
			var fillType:String = GradientType.LINEAR;
			var colors:Array = [0xFFFFFF, 0xFFFFFF];
			var alphas:Array = [0.7, 0.1];
			var ratios:Array = [0x00, 0xFF];
			var matr:Matrix = new Matrix();
			matr.createGradientBox(this.w/2, this.h/2, Math.PI / 2, 0, 0);
			var spreadMethod:String = SpreadMethod.PAD;
			child.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr, spreadMethod);
            child.graphics.drawRoundRect(1, 1, this.w - 2, this.h/2, this.cornerRadius);
            child.graphics.endFill();
			return child;
        }
		
		private function doDropShadow(clip:Sprite):void{
            var color:Number = 0x000000;
            var angle:Number = this.drop.angle;
            var alpha:Number = this.drop.alphashadow / 100;
            var blurX:Number = this.drop.blur;
            var blurY:Number = this.drop.blur;
            var distance:Number = this.drop.distance;
            var strength:Number = 0.65;
            var inner:Boolean = false;
            var knockout:Boolean = false;
            var quality:Number = BitmapFilterQuality.HIGH;
            var dropfilter = new DropShadowFilter(distance,angle,color,alpha,blurX,blurY,strength,quality,inner,knockout);
            var myFilters:Array = new Array();
            myFilters.push(dropfilter);
            clip.filters = myFilters;
        }

        private function configureLabel():void {
			this.label = new TextField();
			this.label.text = this.labelText;
			this.label.x = 0;
			this.label.width = this.w;
			this.label.antiAliasType = AntiAliasType.ADVANCED;
            this.label.autoSize = TextFieldAutoSize.CENTER;
            this.format = new TextFormat();
            this.format.color = this.fontcolor;
            this.format.size = this.fontsize;
			this.format.bold = this.strong;
			this.format.font = this.fontstyle.fontName;
            this.label.setTextFormat(this.format);
			this.label.y = this.h/2 - this.label.textHeight/2;
            this.box.addChild(this.label);
        }
	}
}